﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DES
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //sample of how its called , value and 64 bit key (8 chars)
        private void button1_Click(object sender, EventArgs e)
        {
            string result1 = DES_cipher(textBox1.Text, textBox2.Text);
            textBox3.Text = result1;
            string result2 = DES_decipher(result1, "mypasswd");

        }

        //reverse, returns string
        private string DES_decipher(string inhex, string kystr)
        {

            string inbin = hex2binary(inhex);
            string othex, otstr;
            string sideL, sideR;
            string in48a, in32a, in32b, in32c, xor48, final;

            int[] iperm = stringToArrayInt("58,50,42,34,26,18,10,02,60,52,44,36,28,20,12,04,62,54,46,38,30,22,14,06,64,56,48,40,32,24,16,08,57,49,41,33,25,17,09,01,59,51,43,35,27,19,11,03,61,53,45,37,29,21,13,05,63,55,47,39,31,23,15,07");
            int[] fperm = stringToArrayInt("40,08,48,16,56,24,64,32,39,07,47,15,55,23,63,31,38,06,46,14,54,22,62,30,37,05,45,13,53,21,61,29,36,04,44,12,52,20,60,28,35,03,43,11,51,19,59,27,34,02,42,10,50,18,58,26,33,01,41,09,49,17,57,25");
            int[] expan = stringToArrayInt("32,01,02,03,04,05,04,05,06,07,08,09,08,09,10,11,12,13,12,13,14,15,16,17,16,17,18,19,20,21,20,21,22,23,24,25,24,25,26,27,28,29,28,29,30,31,32,01");
            int[] perm1 = stringToArrayInt("57,49,41,33,25,17,09,01,58,50,42,34,26,18,10,02,59,51,43,35,27,19,11,03,60,52,44,36,63,55,47,39,31,23,15,07,62,54,46,38,30,22,14,06,61,53,45,37,29,21,13,05,28,20,12,04");
            int[] perm2 = stringToArrayInt("14,17,11,24,01,05,03,28,15,06,21,10,23,19,12,04,26,08,16,07,27,20,13,02,41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32");
            int[] perm3 = stringToArrayInt("16,07,20,21,29,12,28,17,01,15,23,26,05,18,31,10,02,08,24,14,32,27,03,09,19,13,30,06,22,11,04,25");
            string kyhex = ConvertStringToHex(kystr);
            string kybin = hex2binary(kyhex);
            string kypr1 = permute(kybin, perm1); //key Initial PERMUTE 64bits to 56bits
            string[] akeys = getkeys(kypr1, perm2);
            string kypr2;
            string temp, tempfinal = "";
            while (inbin.Length > 0)
            {
                temp = inbin.PadRight(64, '0').Substring(0, 64); //64 bits at a time
                if (inbin.Length > 64) { inbin = inbin.Substring(64); } else { inbin = ""; }
                string in64a = permute(temp, iperm); //input Initial PERMUTE
                for (int i = 16; i >= 1; i--) //16 rounds but reversed
                {
                    kypr2 = akeys[i - 1];
                    sideL = in64a.Substring(0, 32); //split input left side 32 bits
                    sideR = in64a.Substring(32, 32); //split input right side 32 bits
                    in48a = permute(sideR, expan); //permute 32bit to 48bit
                    xor48 = strxor(in48a, kypr2);  //XOR 4bit with 48bit key from Round
                    in32a = box64(xor48); //subsitution boxes 48bit to 32bit 
                    in32b = permute(in32a, perm3); //stright permute 32bit to 32bit
                    in32c = strxor(in32b, sideL);
                    if (i != 1) { sideL = sideR; sideR = in32c; } //swap except on round 16
                    else { sideL = in32c; }
                    in64a = sideL + sideR; //combine key
                }
                final = permute(in64a, fperm); //input final permute
                tempfinal = tempfinal + final; //add
            }
            //pop the extra 0000000 bits at the end
            while(tempfinal.Substring(tempfinal.Length-8)=="00000000")
            {
                tempfinal = tempfinal.Substring(0, tempfinal.Length - 8);
            }
            othex = binary2hex(tempfinal); //DEBUG
            otstr = ConvertHexToString(othex);
            return otstr;
        }

        //returns a string as hex, because encryted data is binary
        private string DES_cipher(string instr, string kystr)
        {

            string inhex = ConvertStringToHex(instr);
            string inbin = hex2binary(inhex);
            string othex;
            string sideL, sideR;
            string in48a, in32a, in32b, in32c, xor48, final;

            int[] iperm = stringToArrayInt("58,50,42,34,26,18,10,02,60,52,44,36,28,20,12,04,62,54,46,38,30,22,14,06,64,56,48,40,32,24,16,08,57,49,41,33,25,17,09,01,59,51,43,35,27,19,11,03,61,53,45,37,29,21,13,05,63,55,47,39,31,23,15,07");
            int[] fperm = stringToArrayInt("40,08,48,16,56,24,64,32,39,07,47,15,55,23,63,31,38,06,46,14,54,22,62,30,37,05,45,13,53,21,61,29,36,04,44,12,52,20,60,28,35,03,43,11,51,19,59,27,34,02,42,10,50,18,58,26,33,01,41,09,49,17,57,25");
            int[] expan = stringToArrayInt("32,01,02,03,04,05,04,05,06,07,08,09,08,09,10,11,12,13,12,13,14,15,16,17,16,17,18,19,20,21,20,21,22,23,24,25,24,25,26,27,28,29,28,29,30,31,32,01");
            int[] perm1 = stringToArrayInt("57,49,41,33,25,17,09,01,58,50,42,34,26,18,10,02,59,51,43,35,27,19,11,03,60,52,44,36,63,55,47,39,31,23,15,07,62,54,46,38,30,22,14,06,61,53,45,37,29,21,13,05,28,20,12,04");
            int[] perm2 = stringToArrayInt("14,17,11,24,01,05,03,28,15,06,21,10,23,19,12,04,26,08,16,07,27,20,13,02,41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32");
            int[] perm3 = stringToArrayInt("16,07,20,21,29,12,28,17,01,15,23,26,05,18,31,10,02,08,24,14,32,27,03,09,19,13,30,06,22,11,04,25");
            string kyhex = ConvertStringToHex(kystr);
            string kybin = hex2binary(kyhex);
            string kypr1 = permute(kybin, perm1); //key Initial PERMUTE 64bits to 56bits
            string[] akeys = getkeys(kypr1, perm2);
            string kypr2;
            string temp, tempfinal="";
            while (inbin.Length>0)
            {
                temp = inbin.PadRight(64, '0').Substring(0, 64); //64 bits at a time
                if (inbin.Length > 64) { inbin = inbin.Substring(64); } else { inbin = "";}
                string in64a = permute(temp, iperm); //input Initial PERMUTE
                for (int i = 1; i <= 16; i++) //16 rounds
                {
                    kypr2 = akeys[i - 1];
                    sideL = in64a.Substring(0, 32); //split input left side 32 bits
                    sideR = in64a.Substring(32, 32); //split input right side 32 bits
                    in48a = permute(sideR, expan); //permute 32bit to 48bit
                    xor48 = strxor(in48a, kypr2);  //XOR 4bit with 48bit key from Round
                    in32a = box64(xor48); //subsitution boxes 48bit to 32bit 
                    in32b = permute(in32a, perm3); //stright permute 32bit to 32bit
                    in32c = strxor(in32b, sideL);
                    if (i != 16) { sideL = sideR; sideR = in32c; } //swap except on round 16
                    else { sideL = in32c; }
                    in64a = sideL + sideR; //combine key
                }
                final = permute(in64a, fperm); //input final permute
                tempfinal = tempfinal + final; //add
            }
            othex = binary2hex(tempfinal); //DEBUG
            return othex;
        }

        //get round keys
        private string[] getkeys(string mykey, int[] perm2)
        {
            string[] akeys = new string[16];
            for (int i = 1; i <= 16; i++) //16 rounds
            {
                string prkey;
                mykey = keyshift(mykey, i, true); //get key by shift
                prkey = permute(mykey, perm2);  //key permute 56 bit to 48 bit
                akeys[i-1] = prkey;
            }
            return akeys;
        }

        //key shift
        private string keyshift(string key, int round, bool left)
        {
            switch (round)
            {
                case 17:
                    return key; //used in reverse only
                case 1:
                case 2:
                case 9:
                case 16:
                    if (left) { return key.Substring(1, 27) + key.Substring(0, 1) + key.Substring(29, 27) + key.Substring(28, 1); } //left
                    else      { return key.Substring(27, 1) + key.Substring(0, 27) + key.Substring(55, 1) + key.Substring(28, 27); } //right
               
                default:
                    if (left) { return key.Substring(2, 26) + key.Substring(0, 2) + key.Substring(30, 26) + key.Substring(28, 2); }
                    else      { return key.Substring(26, 2) + key.Substring(0, 26) + key.Substring(54, 2) + key.Substring(28, 26); }
            }

        }

        //binary string to hex string
        private string binary2hex(string binvalue)  //preferable 8 bits at a time, but min requirement is 4 bits
        {
            string result = "";
            string temp = "";
            for (int i = 0; i < (binvalue.Length); i+=4)  //create 1 hex for 4 bits of binary at a time
            {
                temp = binvalue.Substring(i, 4);
                switch (temp)
                {
                    case "0000": result = result + '0'; break;
                    case "0001": result = result + '1'; break;
                    case "0010": result = result + '2'; break;
                    case "0011": result = result + '3'; break;
                    case "0100": result = result + '4'; break;
                    case "0101": result = result + '5'; break;
                    case "0110": result = result + '6'; break;
                    case "0111": result = result + '7'; break;
                    case "1000": result = result + '8'; break;
                    case "1001": result = result + '9'; break;
                    case "1010": result = result + 'A'; break;
                    case "1011": result = result + 'B'; break;
                    case "1100": result = result + 'C'; break;
                    case "1101": result = result + 'D'; break;
                    case "1110": result = result + 'E'; break;
                    case "1111": result = result + 'F'; break;
                }
            }
            return result;
        }

        //hex string to binary
        private string hex2binary(string hexvalue)
        {
            string result="";
            for(int i=0;i<(hexvalue.Length);i++)  //create 4 bits of binary at a time for 1 hex characters
            {
                result = result + Convert.ToString(Convert.ToInt64(hexvalue.Substring(i, 1),16),2).PadLeft(4,'0');
            }
            return result;
        }

        //regular text to hex
        private string ConvertStringToHex(string asciiString)
        {
            string hex = "";
            foreach (char c in asciiString)
            {
                int tmp = c;
                hex += String.Format("{0:x2}", (uint)System.Convert.ToUInt32(tmp.ToString()));
            }
            return hex;
        }

        //hex to regular string
        private string ConvertHexToString(string HexValue)
        {
            string StrValue = "";
            while (HexValue.Length > 0)
            {
                StrValue += System.Convert.ToChar(System.Convert.ToUInt32(HexValue.Substring(0, 2), 16)).ToString();
                HexValue = HexValue.Substring(2, HexValue.Length - 2);
            }
            return StrValue;
        }

        //string to array of integers
        private int[] stringToArrayInt(string val)
        {
            return val.Split(',').Select(str => int.Parse(str)).ToArray();
        }

        //xor caall
        private string strxor(string val, string key)
        {
            string temp = "";
            //items need to be same length, else unexpected results
            for (int i =0;i < val.Length;i++)
            {
                temp = temp + (Int32.Parse(val.Substring(i, 1)) ^ Int32.Parse(key.Substring(i, 1))).ToString();
            }
            return temp;
        }

        //permute based on perm array
        private string permute(string val, int[] perm)
        {
            string result= "";
            for(int i=0;i < perm.Length;i++)
            {
                result = result + val.Substring(perm[i]- 1, 1);
            }
            return result;
        }

        //sbox
        private string box64(string inv48)
        {
            string result = "";
            int[] asubx1 = stringToArrayInt("14,4,13,1,2,15,11,8,3,10,6,12,5,9,0,7,0,15,7,4,14,2,13,1,10,6,12,11,9,5,3,8,4,1,14,8,13,6,2,11,15,12,9,7,3,10,5,0,15,12,8,2,4,9,1,7,5,11,3,14,10,0,6,13");
            int[] asubx2 = stringToArrayInt("15,1,8,14,6,11,3,4,9,7,2,13,12,0,5,10,3,13,4,7,15,2,8,14,12,0,1,10,6,9,11,5,0,14,7,11,10,4,13,1,5,8,12,6,9,3,2,15,13,8,10,1,3,15,4,2,11,6,7,12,0,5,14,9");
            int[] asubx3 = stringToArrayInt("10,0,9,14,6,3,15,5,1,13,12,7,11,4,2,8,13,7,0,9,3,4,6,10,2,8,5,14,12,11,15,1,13,6,4,9,8,15,3,0,11,1,2,12,5,10,14,7,1,10,13,0,6,9,8,7,4,15,14,3,11,5,2,12");
            int[] asubx4 = stringToArrayInt("7,13,14,3,0,6,9,10,1,2,8,5,11,12,4,15,13,8,11,5,6,15,0,3,4,7,2,12,1,10,14,9,10,6,9,0,12,11,7,13,15,1,3,14,5,2,8,4,3,15,0,6,10,1,13,8,9,4,5,11,12,7,2,14");
            int[] asubx5 = stringToArrayInt("2,12,4,1,7,10,11,6,8,5,3,15,13,0,14,9,14,11,2,12,4,7,13,1,5,0,15,10,3,9,8,6,4,2,1,11,10,13,7,8,15,9,12,5,6,3,0,14,11,8,12,7,1,14,2,13,6,15,0,9,10,4,5,3");
            int[] asubx6 = stringToArrayInt("12,1,10,15,9,2,6,8,0,13,3,4,14,7,5,11,10,15,4,2,7,12,9,5,6,1,13,14,0,11,3,8,9,14,15,5,2,8,12,3,7,0,4,10,1,13,11,6,4,3,2,12,9,5,15,10,11,14,1,7,6,0,8,13");
            int[] asubx7 = stringToArrayInt("4,11,2,14,15,0,8,13,3,12,9,7,5,10,6,1,13,0,11,7,4,9,1,10,14,3,5,12,2,15,8,6,1,4,11,13,12,3,7,14,10,15,6,8,0,5,9,2,6,11,13,8,1,4,10,7,9,5,0,15,14,2,3,12");
            int[] asubx8 = stringToArrayInt("13,2,8,4,6,15,11,1,10,9,3,14,5,0,12,7,1,15,13,8,10,3,7,4,12,5,6,11,0,14,9,2,7,11,4,1,9,12,14,2,0,6,10,13,15,3,5,8,2,1,14,7,4,10,8,13,15,12,9,0,3,5,6,11");

            // get 4 bits from 6 bits , 8 times , thus goes from 48bit to 32bit
            // the 1st and 6th bit are used for the substitution box row, the 2nd,3rd,4th,and 5th bit are used for the column
            // I store it as one array and multiple the row by 16 to get the postion in the array
            // example
            // subx1
            //   00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 
            //0: 14,04,13,01,02,15,11,08,03,10,06,12,05,09,00,07,
            //1: 00,15,07,04,14,02,13,01,10,06,12,11,09,05,03,08,
            //2: 04,01,14,08,13,06,02,11,15,12,09,07,03,10,05,00,
            //3: 15,12,08,02,04,09,01,07,05,11,03,14,10,00,06,13
            //
            // if input 6 bits was "011011" on subx1 , that means row "0xxxx1" aka (1)  and col "x1101x" aka (13)
            // the tables value is shown in decimal (for readability, so row_1,col_13 = 05 or in binary would be "0101"
            // thus "011011" goes to "0101"

            for (int i = 0; i < 8; i++) 
            {
                int row = Convert.ToInt32(inv48.Substring(0+(i*6), 1) + inv48.Substring(5+(i*6), 1), 2);
                int col = Convert.ToInt32(inv48.Substring(1+(i*6), 4), 2);
                switch(i)
                {
                    case 0:
                        result = result + Convert.ToString(asubx1[((row * 16) + col)], 2).PadLeft(4,'0');
                        break;
                    case 1:
                        result = result + Convert.ToString(asubx2[((row * 16) + col)], 2).PadLeft(4, '0');
                        break;
                    case 2:
                        result = result + Convert.ToString(asubx3[((row * 16) + col)], 2).PadLeft(4, '0');
                        break;
                    case 3:
                        result = result + Convert.ToString(asubx4[((row * 16) + col)], 2).PadLeft(4, '0');
                        break;
                    case 4:
                        result = result + Convert.ToString(asubx5[((row * 16) + col)], 2).PadLeft(4, '0');
                        break;
                    case 5:
                        result = result + Convert.ToString(asubx6[((row * 16) + col)], 2).PadLeft(4, '0');
                        break;
                    case 6:
                        result = result + Convert.ToString(asubx7[((row * 16) + col)], 2).PadLeft(4, '0');
                        break;
                    case 7:
                        result = result + Convert.ToString(asubx8[((row * 16) + col)], 2).PadLeft(4, '0');
                        break;
                    default:
                        break;
                
                }

            }
            return result;

        }

        //sample of how its called , decipher
        private void button2_Click(object sender, EventArgs e)
        {
            string result1 = DES_decipher(textBox6.Text, textBox5.Text);
            textBox4.Text = result1;
        }
    }
}
